SystemOrganization addCategory: #'Xtreams-Parsing'!

Object subclass: #PEGActor
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!PEGActor class methodsFor: 'pragmas' stamp: 'nice 1/14/2011 22:25'!
pragmas
	<pragmas: #instance>
	^#( action: action:arguments: )! !

!PEGActor methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:28'!
initialize
	super initialize.
	actions := Dictionary new.
	(Pragma allNamed: #action:arguments: in: self class)
		do: [:pragma | actions at: pragma arguments first put: [:object |
			| arguments |
			arguments := (pragma arguments at: 2) collect: [:i | i <= object size ifTrue: [object at: i] ifFalse: [nil]].
			self perform: pragma selector withArguments: arguments]].
	(Pragma allNamed: #action: in: self class)
		do: [:pragma | actions at: pragma arguments first put: [:object |
			self perform: pragma selector with: object]].! !

!PEGActor methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:28'!
process: name object: object start: start stop: stop
	| action |
	action := actions at: name ifAbsent: [^object].
	^action value: object! !

PEGActor subclass: #PEGParserGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!PEGParserGenerator methodsFor: 'modifiers' stamp: 'nice 1/14/2011 22:47'!
AND
	<action: 'AND' arguments: #()>
	^'generator AND'! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:45'!
Cardinality: cardinality
	<action: 'Cardinality' arguments: #( 3 )>
	^cardinality! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:45'!
CardinalityLoop: test
	<action: 'CardinalityLoop'>
	^'(generator CardinalityLoop: ', test, ')'! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:45'!
CardinalityLoopMin: min test: test
	<action: 'CardinalityLoopMin' arguments: #( 1 5 )>
	^'(generator CardinalityLoopMin: ', min, ' test: ', test, ')'! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:46'!
CardinalityRange: min max: max
	<action: 'CardinalityRange' arguments: #( 1 5 )>
	^'(generator CardinalityRangeMin: ', min, ' max: ', max, ')'! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:46'!
CardinalityRangeMin: min
	<action: 'CardinalityRangeMin'>
	^'(generator CardinalityRangeMin: ', min, ')'! !

!PEGParserGenerator methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:49'!
DOT
	<action: 'DOT' arguments: #()>
	^'generator DOT'! !

!PEGParserGenerator methodsFor: 'structural' stamp: 'nice 1/14/2011 22:48'!
Definition: identifier expression: expression
	<action: 'Definition' arguments: #( 2 6 )>

	^'(generator Definition: ', identifier, ' expression: ', expression, ')'! !

!PEGParserGenerator methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:46'!
Escape: backslash character: character hexes: hexes
	<action: 'Escape' arguments: #( 1 2 3 )>

	backslash = '\' ifTrue:
		[character = $s ifTrue: [^Character space].
		character = $t ifTrue: [^Character tab].
		character = $n ifTrue: [^Character cr].
		character = $r ifTrue: [^Character lf].
		character = $x ifTrue: [^('16r', (String withAll: hexes)) asNumber asCharacter]].
	^character! !

!PEGParserGenerator methodsFor: 'structural' stamp: 'nice 1/14/2011 22:48'!
Expression: first rest: rest
	<action: 'Expression' arguments: #( 1 2 )>

	rest isEmpty ifTrue: [^first].
	^'(generator Expression: ', first, ' rest: ', (self collection: (rest collect: [:each | '(Array with: ''/'' with: #() with: ', each last, ')'])), ')'! !

!PEGParserGenerator methodsFor: 'structural' stamp: 'nice 1/14/2011 22:48'!
Grammar: definitions
	<action: 'Grammar' arguments: #( 1 )>

	| stream |
	stream := String new writing.
	stream
		tab; write: '| generator definitions |'; cr;
		tab; write: 'definitions := OrderedCollection new.'; cr;
		tab; write: 'generator := PEGParserParser new.'; cr.
	definitions do: [:source | stream tab; write: 'definitions add: '; write: source; write: $.; cr].
	stream tab; write: '^generator Grammar: definitions'.
	^stream contents! !

!PEGParserGenerator methodsFor: 'structural' stamp: 'nice 1/14/2011 22:48'!
Group: expression
	<action: 'Group' arguments: #( 3 )>

	^expression! !

!PEGParserGenerator methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:47'!
Identifier: first rest: rest
	<action: 'Identifier' arguments: #( 1 2 )>

	| stream |
	stream := (String new: rest size + 3) writing.
	stream put: $'.
	stream put: first.
	rest notEmpty ifTrue: [stream write: rest].
	stream put: $'.
	^stream contents! !

!PEGParserGenerator methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:49'!
Literal: characters
	<action: 'Literal' arguments: #( 2 )>

	| stream |
	stream := String new writing.
	stream write: '(generator Literal: '''.
	(stream transforming: [:in :out | | each |
		each := in get.
		each = $' ifTrue: [out put: $'].
		out put: each]) write: characters.
	stream write: ''')'.
	^stream contents! !

!PEGParserGenerator methodsFor: 'modifiers' stamp: 'nice 1/14/2011 22:47'!
NOT
	<action: 'NOT' arguments: #()>
	^'generator NOT'! !

!PEGParserGenerator methodsFor: 'structural' stamp: 'nice 1/14/2011 22:48'!
Node: primary modifier: modifier cardinality: cardinality
	<action: 'Node' arguments: #( 2 1 3 )>

	(modifier isNil and: [cardinality isNil]) ifTrue: [^primary].
	^'(generator Node: ', primary,
		' modifier: ', (modifier ifNil: ['nil'] ifNotNil: [modifier]),
		' cardinality: ', (cardinality ifNil: ['nil'] ifNotNil: [cardinality]), ')'! !

!PEGParserGenerator methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:47'!
NumLiteral: digit rest: digits
	<action: 'NumLiteral' arguments: #( 1 2 )>

	| number |
	number := String new writing.
	number put: digit.
	digits isEmpty ifFalse: [number write: digits].
	^number contents! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:46'!
PLUS
	<action: 'PLUS' arguments: #()>
	^'generator PLUS'! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:46'!
QUESTION
	<action: 'QUESTION' arguments: #()>
	^'generator QUESTION'! !

!PEGParserGenerator methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:49'!
Range: excluding sets: sets
	<action: 'Range' arguments: #( 3 4 )>

	^'(generator Range: ', (excluding ifNil: ['nil'] ifNotNil: [excluding]), ' sets: ', (self collection: sets), ')'! !

!PEGParserGenerator methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:47'!
RangeSet: first to: second
	<action: 'RangeSet' arguments: #( 2 4 )>

	second ifNil: [^(Interval from: first asInteger to: first asInteger) printString].
	^(Interval from: first asInteger to: second asInteger) printString! !

!PEGParserGenerator methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:49'!
Reference: identifier
	<action: 'Reference' arguments: #( 1 )>

	^'(generator Reference: ', identifier, ')'! !

!PEGParserGenerator methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:46'!
STAR
	<action: 'STAR' arguments: #()>
	^'generator STAR'! !

!PEGParserGenerator methodsFor: 'structural' stamp: 'nice 1/14/2011 22:48'!
Sequence: nodes
	<action: 'Sequence'>

	nodes size = 1 ifTrue: [^nodes first].
	^'(generator Sequence: ', (self collection: nodes), ')'! !

!PEGParserGenerator methodsFor: 'private' stamp: 'nice 1/14/2011 22:47'!
collection: aCollection
	| stream |
	stream := String new writing.
	stream write: '(OrderedCollection new'.
	aCollection do: [:each |
		stream write: ' add: '.
		stream write: each.
		stream write: ';'].
	stream write: ' yourself)'.
	^stream contents! !

PEGActor subclass: #PEGParserParser
	instanceVariableNames: 'parser references useCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!PEGParserParser methodsFor: 'modifiers' stamp: 'nice 1/14/2011 22:43'!
AND
	<action: 'AND' arguments: #()>
	^[:expression | [parser explore: expression]]! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:40'!
Cardinality: cardinality
	<action: 'Cardinality' arguments: #( 3 )>
	^cardinality! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:40'!
CardinalityLoop: test
	<action: 'CardinalityLoop'>
	^[:expression | [parser repeat: expression min: 0 test: test]]! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:40'!
CardinalityLoopMin: min test: test
	<action: 'CardinalityLoopMin' arguments: #( 1 5 )>
	^[:expression | [parser repeat: expression min: min test: test]]! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:40'!
CardinalityRange: min max: max
	<action: 'CardinalityRange' arguments: #( 1 5 )>
	| optional |
	optional := max - min.
	^(min isZero and: [max = 1])
		ifTrue:	[ [:expression | [parser optional: expression]] ]
		ifFalse:	[ [:expression | [parser repeat: expression min: min optional: optional]] ]! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:40'!
CardinalityRangeMin: min
	<action: 'CardinalityRangeMin'>
	^[:expression | [parser repeat: expression min: min optional: 0]]! !

!PEGParserParser methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:44'!
DOT
	<action: 'DOT' arguments: #()>
	^[parser anything]! !

!PEGParserParser methodsFor: 'structural' stamp: 'nice 1/14/2011 22:43'!
Definition: identifier expression: expression
	<action: 'Definition' arguments: #( 2 6 )>

	| cache |
	useCache ifFalse: [ ^identifier -> [parser definition: expression name: identifier] ].

	parser caches add: (cache := Dictionary new).
	^identifier -> [parser definition: expression name: identifier cache: cache]! !

!PEGParserParser methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:42'!
Escape: backslash character: character hexes: hexes
	<action: 'Escape' arguments: #( 1 2 3 )>

	backslash = '\' ifTrue:
		[character = $s ifTrue: [^Character space].
		character = $t ifTrue: [^Character tab].
		character = $n ifTrue: [^Character cr].
		character = $r ifTrue: [^Character lf].
		character = $x ifTrue: [^('16r', (String withAll: hexes)) asNumber asCharacter]].
	^character! !

!PEGParserParser methodsFor: 'structural' stamp: 'nice 1/14/2011 22:43'!
Expression: first rest: rest
	<action: 'Expression' arguments: #( 1 2 )>

	| sequences |
	rest isEmpty ifTrue: [^first].
	sequences := (Array with: first), (rest collect: [:each | each last]).
	^[parser any: sequences]! !

!PEGParserParser methodsFor: 'structural' stamp: 'Martin Kobetic 1/22/2011 18:26'!
Grammar: definitions
	<action: 'Grammar' arguments: #( 1 )>

	| defines |
	defines := Dictionary new.
	definitions do: [ :each | defines at: each key put: each value ].
	references keysAndValuesDo: [:name :dummy | dummy become: (defines at: name)].

	parser grammar addAll: references.
	defines keysAndValuesDo: [:name :definition | definition class == Object ifFalse: [parser grammar at: name put: definition]].
	^parser! !

!PEGParserParser methodsFor: 'structural' stamp: 'nice 1/14/2011 22:43'!
Group: expression
	<action: 'Group' arguments: #( 3 )>

	^expression! !

!PEGParserParser methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:42'!
Identifier: first rest: rest
	<action: 'Identifier' arguments: #( 1 2 )>

	| stream |
	stream := (String new: rest size + 1) writing.
	stream put: first.
	rest notEmpty ifTrue: [stream write: rest].
	^stream contents! !

!PEGParserParser methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:44'!
Literal: characters
	<action: 'Literal' arguments: #( 2 )>

	| stream literal |
	stream := (String new: characters size) writing.
	characters do: [:each | stream put: each].
	literal := stream contents.
	parser bufferSize: literal size.
	^[parser literal: literal]! !

!PEGParserParser methodsFor: 'modifiers' stamp: 'nice 1/14/2011 22:43'!
NOT
	<action: 'NOT' arguments: #()>
	^[:expression | [parser not: expression]]! !

!PEGParserParser methodsFor: 'structural' stamp: 'nice 1/14/2011 22:43'!
Node: primary modifier: modifier cardinality: cardinality
	<action: 'Node' arguments: #( 2 1 3 )>

	| expression |
	expression := primary.
	cardinality ifNotNil: [expression := cardinality value: expression].
	modifier ifNotNil: [expression := modifier value: expression].
	^expression! !

!PEGParserParser methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:56'!
NumLiteral: digit rest: digits
	<action: 'NumLiteral' arguments: #( 1 2 )>

	| number |
	digit = 'Infinity' ifTrue: [^PEGInfinity positive].
	digit = '0' ifTrue: [^0].
	number := String new writing.
	number put: digit.
	digits isEmpty ifFalse: [number write: digits].
	^number contents asNumber! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:57'!
PLUS
	<action: 'PLUS' arguments: #()>
	^[:expression | [parser repeat: expression min: 1 optional: PEGInfinity positive]]! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:41'!
QUESTION
	<action: 'QUESTION' arguments: #()>
	^[:expression | [parser optional: expression]]! !

!PEGParserParser methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:44'!
Range: excluding sets: sets
	<action: 'Range' arguments: #( 3 4 )>

	sets isEmpty ifTrue: [
		^excluding
			ifNil:	[self DOT]
			ifNotNil:	[ [parser not: [parser anything]] ]].
	^excluding
		ifNil:	[ [parser including: sets] ]
		ifNotNil:	[ [parser excluding: sets] ]! !

!PEGParserParser methodsFor: 'lexical' stamp: 'nice 1/14/2011 22:42'!
RangeSet: first to: second
	<action: 'RangeSet' arguments: #( 2 4 )>

	second ifNil: [^Interval from: first asInteger to: first asInteger].
	^Interval from: first asInteger to: second asInteger! !

!PEGParserParser methodsFor: 'terminals' stamp: 'nice 1/14/2011 22:44'!
Reference: identifier
	<action: 'Reference' arguments: #( 1 )>

	^references at: identifier ifAbsentPut: [Object new]! !

!PEGParserParser methodsFor: 'cardinality' stamp: 'nice 1/14/2011 22:57'!
STAR
	<action: 'STAR' arguments: #()>
	^[:expression | [parser repeat: expression min: 0 optional: PEGInfinity positive]]! !

!PEGParserParser methodsFor: 'structural' stamp: 'nice 1/14/2011 22:44'!
Sequence: nodes
	<action: 'Sequence'>

	nodes size = 1 ifTrue: [^nodes first].
	^[parser all: nodes]! !

!PEGParserParser methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:41'!
dontUseCache
	useCache := false! !

!PEGParserParser methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:53'!
initialize
	super initialize.
	useCache := false.
	parser := PEGParser new.
	references := Dictionary new! !

!PEGParserParser methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:42'!
useCache
	useCache := true! !

Object subclass: #PEGInfinity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!PEGInfinity class methodsFor: 'instance creation' stamp: 'nice 1/14/2011 22:56'!
positive
	^self new! !

!PEGInfinity methodsFor: 'enumerating' stamp: 'nice 1/14/2011 22:55'!
timesRepeat: aBlock
	aBlock repeat! !

Object subclass: #PEGParser
	instanceVariableNames: 'grammar stream actor cache caches'
	classVariableNames: 'Failure'
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:34'!
grammarCSS3
^'/* CSS3 grammar: */
/* Tokenization: */
ident 				<-	MINUS? nmstart nmchar*
name 				<-	nmchar+
nmstart 				<-	[a-zA-Z] / UNDERSCORE / nonascii / escape
/* The unicode chars larger than \x00FFFF do not produce correct character codes. 
nonascii 			<-	[\x000080-\x00D7FF] / [\x00E000-\x00FFFD] / [\x010000-\x10FFFF] */
nonascii 			<-	[\x000080-\x00D7FF\x00E000-\x00FFFD]
unicode 				<-	BACKSLASH [0-9a-fA-F]{1,6} wc?
escape 				<-	unicode / BACKSLASH [\x000020-\x00007E\x000080-\x00D7FF\x00E000-\x00FFFD\x010000-\x10FFFF]
nmchar 				<-	[a-zA-Z0-9] / MINUS / UNDERSCORE / nonascii / escape
num 				<-	DECIMALDIGIT+ / DECIMALDIGIT* DOT DECIMALDIGIT+
string 				<-	DOUBLEQUOTE (stringchar / SINGLEQUOTE)* DOUBLEQUOTE
					/	SINGLEQUOTE (stringchar / DOUBLEQUOTE)* SINGLEQUOTE
stringchar 			<-	urlchar / [\x000020] / BACKSLASH nl
urlchar 				<-	[\x000009\x000021\x000023-\x000026\x000027-\x00007E] / nonascii / escape
nl 					<-	[\x00000A] / [\x00000D] [\x00000A] / [\x00000D] / [\x00000C]
w 					<-	wc*
wc 					<-	[\x000009] / [\x00000A] / [\x00000C] / [\x00000D] / [\x000020]
/* CSS3 Tokens: */
IDENT 				<-	ident
ATKEYWORD 		<-	AT ident
STRING 			<-	string
HASH 				<-	HASHCHAR name
NUMBER 			<-	num
PERCENTAGE 		<-	num PERCENTSIGN
DIMENSION 			<-	num ident
URI 				<-	cU cR cL OPEN w (string / urlchar*) w CLOSE
UNICODERANGE 	<-	cU PLUS [0-9A-F]{1,6} (MINUS [0-9A-F]{1,6})?
CDO 				<-	"<!!--"
CDC 				<-	"-->"
S 					<-	wc+
COMMENT 			<-	FORWARDSLASH ASTERISK [^*]* ASTERISK+ ([^/] [^*]* ASTERISK+)* FORWARDSLASH
FUNCTION 			<-	ident OPEN
INCLUDES 			<-	"~="
DASHMATCH 		<-	"|="
PREFIXMATCH 		<-	"^="
SUFFIXMATCH 		<-	"$="
SUBSTRINGMATCH 	<-	"*="
CHAR 				<-	!!(&DOUBLEQUOTE) !!(&SINGLEQUOTE) .
BOM 				<-	[\x00FEFF]
 
/* CSS2 grammar follows: */
stylesheet			<-	(CHARSETSYM STRING SEMICOLON)?
						(S / CDO / CDC)* ( import ( CDO S* / CDC S* )* )*
						(namespace (S / CDO / CDC)* )*
						( ( ruleset / media / page ) ( CDO S* / CDC S* )* )*
						S* !!.
import 				<-	IMPORTSYM S*
						(STRING / URI) S* medialist? SEMICOLON S*
namespace 			<-	NAMESPACESYM S* (namespaceprefix S*)? (STRING / URI) S*
namespaceprefix 	<-	IDENT
media 				<-	MEDIASYM S* medialist OPENCURLY S* ruleset* CLOSECURLY S*
medialist 			<-	medium ( COMMA S* medium)*
medium 				<-	IDENT S*
page 				<-	PAGESYM S* pseudopage?
						OPENCURLY S* declaration? ( SEMICOLON S* declaration? )* CLOSECURLY S*
pseudopage 		<-	COLON IDENT S*
operator 			<-	FORWARDSLASH S* / COMMA S* /* / EMPTY */
combinator 			<-	PLUS S* / GREATER S* /* / EMPTY */
unaryoperator 		<-	MINUS / PLUS
property 			<-	IDENT S*
ruleset 				<-	selector (COMMA S* selector)*
						OPENCURLY S* (declaration ( SEMICOLON S* declaration? )*)? CLOSECURLY S*
selector 				<-	simpleselector (combinator selector / S+ ( combinator? selector )? )?
simpleselector 		<-	elementname? ( HASH / class / attrib / pseudo )* S*
class 				<-	DOT IDENT
elementname 		<-	IDENT / ASTERISK
attrib 				<-	OPENSQUARE S* IDENT S* ( ( EQUAL / INCLUDES / DASHMATCH ) S* ( IDENT / STRING ) S* )? CLOSESQUARE
pseudo 				<-	COLON ( IDENT / FUNCTION S* (IDENT S*)? CLOSE )
declaration 			<-	property COLON S* expr prio?
prio 				<-	IMPORTANTSYM S*
expr 				<-	term ( operator term )*
term 				<-	unaryoperator? (( PERCENTAGE / LENGTH / EMS / EXS / ANGLE / TIME / FREQ / NUMBER ) S* / function)
					/	(STRING / IDENT / URI / UNICODERANGE) S*
					/	hexcolor
function 				<-	FUNCTION S* expr CLOSE S*
hexcolor 			<-	HASHCHAR h h h
					/	HASHCHAR h h h h h h

/* Lexical Syntax */
h 					<-	[0-9a-fA-F]
CHARSETSYM 		<-	AT cC cH cA cR cS cE cT
IMPORTSYM 		<-	AT cI cM cP cO cR cT
MEDIASYM 			<-	AT cM cE cD cI cA
PAGESYM 			<-	AT cP cA cG cE
FONTFACESYM 		<-	AT cF cO cN cT DASH cF cA cC cE
NAMESPACESYM 	<-	AT cN cA cM cE cS cP cA cC cE
IMPORTANTSYM 	<-	EXCLAMATION w  cI cM cP cO cR cT cA cN cT

EMS 				<-	num cE cM
EXS 				<-	num cE cX
LENGTH 			<-	num (cP cX / cC cM / cM cM / cI cN / cP cT / cP cC)
ANGLE 				<-	num (cD cE cG / cG? cR cA cD)
TIME 				<-	num cM? cS
FREQ 				<-	num cK? cH cZ
DIMEN 				<-	num ident

/* CSS is case-insensitive. Moreover, letters may be expressed in hex form. cA - cZ definitions address this. */
cA 					<-	[aA] / BACKSLASH [0]{0,4} ([46] [1]) nl?
cB 					<-	[bB] / BACKSLASH [0]{0,4} ([46] [2]) nl?
cC 					<-	[cC] / BACKSLASH [0]{0,4} ([46] [3]) nl?
cD 					<-	[dD] / BACKSLASH [0]{0,4} ([46] [4]) nl?
cE 					<-	[eE] / BACKSLASH [0]{0,4} ([46] [5]) nl?
cF 					<-	[fF] / BACKSLASH [0]{0,4} ([46] [6]) nl?
cG 					<-	[gG] / BACKSLASH [0]{0,4} ([46] [7]) nl?
cH 					<-	[hH] / BACKSLASH [0]{0,4} ([46] [8]) nl?
cI 					<-	[iI] / BACKSLASH [0]{0,4} ([46] [9]) nl?
cJ 					<-	[jJ] / BACKSLASH [0]{0,4} ([46] [aA]) nl?
cK 					<-	[kK] / BACKSLASH [0]{0,4} ([46] [bB]) nl?
cL 					<-	[lL] / BACKSLASH [0]{0,4} ([46] [cC]) nl?
cM 					<-	[mM] / BACKSLASH [0]{0,4} ([46] [dD]) nl?
cN 					<-	[nN] / BACKSLASH [0]{0,4} ([46] [eE]) nl?
cO 					<-	[oO] / BACKSLASH [0]{0,4} ([46] [fF]) nl?
cP 					<-	[pP] / BACKSLASH [0]{0,4} ([57] [0]) nl?
cQ 					<-	[qQ] / BACKSLASH [0]{0,4} ([57] [1]) nl?
cR 					<-	[rR] / BACKSLASH [0]{0,4} ([57] [2]) nl?
cS 					<-	[sS] / BACKSLASH [0]{0,4} ([57] [3]) nl?
cT 					<-	[tT] / BACKSLASH [0]{0,4} ([57] [4]) nl?
cU 					<-	[uU] / BACKSLASH [0]{0,4} ([57] [5]) nl?
cV 					<-	[vV] / BACKSLASH [0]{0,4} ([57] [6]) nl?
cW 					<-	[wW] / BACKSLASH [0]{0,4} ([57] [7]) nl?
cX 					<-	[xX] / BACKSLASH [0]{0,4} ([57] [8]) nl?
cY 					<-	[yY] / BACKSLASH [0]{0,4} ([57] [9]) nl?
cZ 					<-	[zZ] / BACKSLASH [0]{0,4} ([57] [aA]) nl?


AT 					<-	"@"
ASTERISK 			<-	"*"
BACKSLASH 		<-	"\\"
CLOSE 				<-	")"
CLOSECURLY 		<-	"}"
CLOSESQUARE 		<-	"]"
COLON 				<-	":"
COMMA 			<-	","
DASH 				<-	"-"
DECIMALDIGIT 		<-	[0-9]
DOT 				<-	"."
DOUBLEQUOTE 		<-	"\""
EMPTY 				<-	""
EQUAL 				<-	"="
EXCLAMATION 		<-	"!!"
FORWARDSLASH 	<-	"/"
GREATER 			<-	">"
HASHCHAR 		<-	"#"
MINUS 				<-	"-"
PERCENTSIGN 		<-	"%"
PLUS 				<-	"+"
OPEN 				<-	"("
OPENCURLY 		<-	"{"
OPENSQUARE 		<-	"["
s 					<-	WS+
SEMICOLON 		<-	";"
SINGLEQUOTE 		<-	"''"
UNDERSCORE 		<-	"_"
w 					<-	s?
WS 				<-	[ \t\r\n\x00000C]
/* End of file */'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:35'!
grammarHttpUrl
^'/* This is an example grammar for toying with */
Http			<-	HTTP User? Host Port? Components? Query? !!.
User		<-	Username (COLON Password)? AT
Port			<-	COLON [0-9]+
Components	<-	(SLASH Component)* SLASH?

Host 		<- Ident (DOT Host)?
Ident 		<- IdentStart IdentCont*
IdentStart 	<- [a-zA-Z]
IdentCont 	<- IdentStart / [_0-9] / "-"
Query 		<- QUESTION KeyValue (AMP KeyValue)*
KeyValue 	<- Key EQUAL Value?
Key			<- Ident
Value		<- Ident
Username	<- Ident
Password	<- IdentCont+
Component	<- Ident (DOT Component)?
AMP 		<- "&"
AT			<- "@"
COLON		<- ":"
DOT 		<- "."
EQUAL 		<- "="
HTTP		<- "http://"
QUESTION 	<- "?"
SLASH		<- "/"
'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:35'!
grammarJSON
^'object		<-	"{" associations? "}"
associations	<-	association ("," association)*
association	<-	string ":" value
array		<-	"[" values? "]"
values		<-	value ("," value)*
value		<-	string / number / object / array / true / false / null
true			<-	"true"
false		<-	"false"
null			<-	"null"
string		<-	["] character{["]}
character	<-	"\\" ["\\/bfnrt]
			/	"\\u" [0-9A-Fa-f]{4}
number		<-	"-"? [0-9]+ ("." [0-9]+)? ([eE] [+-]? [0-9]+)?
'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:35'!
grammarJavascript
^'/* Lexical Grammar */
/* SourceCharacter 			<- . */
/* WhiteSpace 					<- TAB / VT / FF/ SPACE / NBSP / USP */
WhiteSpace 					<- [\s\t\x00000B\x00000C]
/* LineTerminator 				<- LF / CR / LS / PS */
LineTerminator 				<- LF / CR
Comment 					<- MultiLineComment 
							/ SingleLineComment
MultiLineComment 			<- [/] [*] MultiLineCommentChars? [*] [/] 
MultiLineCommentChars 		<- MultiLineNotAsteriskChar+ 
							/ ASTERISK PostAsteriskCommentChars?
PostAsteriskCommentChars 	<- MultiLineNotForwardSlashOrAsteriskChar MultiLineCommentChars? 
							/ ASTERISK PostAsteriskCommentChars?
MultiLineNotAsteriskChar 		<- !!ASTERISK
MultiLineNotForwardSlashOrAsteriskChar 	<- !!(FORWARDSLASH / ASTERISK)
SingleLineComment 			<- "//" .{[\x00000A\x00000D]}
ReservedWord 				<- BooleanLiteral
							/ NullLiteral
							/ Keyword
Keyword 					<- RETURN / BREAK / CASE / CATCH / CONTINUE / DEFAULT / DELETE / DO
							/ ELSE / FINALLY / FOR / FUNCTION / IF / IN / INSTANCEOF
							/ NEW / SWITCH / THIS / THROW / TRY / TYPEOF
							/ VAR / VOID / WHILE / WITH
Identifier 					<- !!(ReservedWord (WhiteSpace / Punctuator)) IdentifierName
IdentifierName 				<- IdentifierStart IdentifierPart*
IdentifierStart 				<- [A-Za-z$_]
							/ BACKSLASH UnicodeEscapeSequence
IdentifierPart 				<- IdentifierStart
							/ DecimalDigit
HexDigit 					<- [0123456789abcdefABCDEF]
Punctuator 					<- "{" / "}" / "(" / ")" / "[" / "]" / "." / SEMICOLON / "," / "<" / ">" / "<=" / ">="
							/ "==" / "!!=" / "===" / "!!==" / "+" / "-" / "*" / PERCENT / "++" / "--" / "<<" / ">>"
							/ ">>>" / AMP / VERTICALBAR / "^" / EXCLAMATION / TILDE / (AMP AMP) / "||" / QUESTION / COLON / EQUAL
							/ "+=" / "-=" / "*=" / "%=" / "<<=" / ">>=" / ">>>=" / "&=" / "|=" / "^="
DivPunctuator 				<- "/" / "/="
Literal 						<- NullLiteral
							/ BooleanLiteral
							/ StringLiteral
							/ NumericLiteral
NullLiteral 					<- "null"
BooleanLiteral 				<- "true" / "false"
NumericLiteral 				<- DecimalLiteral
							/ HexIntegerLiteral
DecimalLiteral 				<- DecimalIntegerLiteral (DOT DecimalDigits?)? ExponentPart?
							/ DOT DecimalDigits ExponentPart?
							/ DecimalIntegerLiteral ExponentPart?
DecimalIntegerLiteral 		<- NonZeroDigit DecimalDigits?
							/ [0]
DecimalDigits 				<- [0123456789]*
NonZeroDigit 				<- [123456789]
DecimalDigit 				<- [0123456789]
ExponentPart 				<- ExponentIndicator SignedInteger
ExponentIndicator 			<- [eE]
SignedInteger 				<- (PLUS / MINUS)? DecimalDigits
HexIntegerLiteral 			<- [0] [xX] HexDigit+
StringLiteral 					<- DOUBLEQUOTE DoubleStringCharacters? DOUBLEQUOTE
							/ SINGLEQUOTE SingleStringCharacters? SINGLEQUOTE
DoubleStringCharacters 		<- DoubleStringCharacter+
SingleStringCharacters 		<- SingleStringCharacter+
DoubleStringCharacter 		<- !!(&(DOUBLEQUOTE / BACKSLASH / LineTerminator)) .
							/ BACKSLASH EscapeSequence
SingleStringCharacter 		<- !!(&(SINGLEQUOTE / BACKSLASH / LineTerminator)) .
							/ BACKSLASH EscapeSequence
EscapeSequence 			<- CharacterEscapeSequence
							/ HexEscapeSequence
							/ UnicodeEscapeSequence
							/ [0] &(!!DecimalDigit)
CharacterEscapeSequence 	<- SingleEscapeCharacter
							/ NonEscapeCharacter
SingleEscapeCharacter 		<- [\''\"\\bfnrtv]
NonEscapeCharacter 		<- !!(&(EscapeCharacter / LineTerminator)) .
EscapeCharacter 			<- SingleEscapeCharacter
							/ DecimalDigit
							/ [xu]
HexEscapeSequence 		<- [x] HexDigit HexDigit
UnicodeEscapeSequence 	<- [u] HexDigit HexDigit HexDigit HexDigit
RegularExpressionLiteral 		<- FORWARDSLASH RegularExpressionBody FORWARDSLASH RegularExpressionFlags
RegularExpressionBody 		<- RegularExpressionFirstChar RegularExpressionChars
RegularExpressionChars 		<- RegularExpressionChar*
RegularExpressionFirstChar 	<- BackslashSequence
							/ !!(&(ASTERISK / BACKSLASH / FORWARDSLASH)) NonTerminator
RegularExpressionChar 		<- BackslashSequence
							/ !!(&(BACKSLASH / FORWARDSLASH)) NonTerminator
BackslashSequence 			<- BACKSLASH NonTerminator
NonTerminator 				<- !!(&LineTerminator) .
RegularExpressionFlags 		<- IdentifierPart*

/* Number Conversions */
StringNumericLiteral 			<- StrWhiteSpace? (StrNumericLiteral StrWhiteSpace?)?
StrWhiteSpace 				<- StrWhiteSpaceChar StrWhiteSpace?

/* This is according to EcmaScript grammar. NBSP, USP, LS & PS - what are their definitions?
StrWhiteSpaceChar 			<- TAB / SPACE / NBSP / FF / VT / CR / LF / LS / PS / USP */

StrWhiteSpaceChar 			<- TAB / SPACE  / FF / VT / CR / LF
StrNumericLiteral 			<- StrDecimalLiteral
							/ HexIntegerLiteral
StrDecimalLiteral 			<- (PLUS / MINUS)? StrUnsignedDecimalLiteral
StrUnsignedDecimalLiteral 	<- INFINITY
							/ DecimalDigits (DOT DecimalDigits)? ExponentPart?
							/ DOT DecimalDigits ExponentPart?
/* Expressions: */
PrimaryExpression 			<- ArrayLiteral
							/ ObjectLiteral
							/ OPEN Expression CLOSE
							/ THIS
							/ Literal
							/ Identifier
ArrayLiteral 					<- OPENSQUARE SS ElementList? (COMMA Elision)? SS CLOSESQUARE
ElementList 					<- Elision? SS AssignmentExpression (Elision? SS AssignmentExpression)*
Elision 						<- SS COMMA (SS COMMA)*
ObjectLiteral 				<- OPENCURLY SS PropertyNameAndValueList? CLOSECURLY / ObjectLiteralError
ObjectLiteralError			<- OPENCURLY .{CLOSECURLY}
PropertyNameAndValueList 	<- (PropertyName SS [:] SS PropertyValue SS)+
PropertyValue				<- AssignmentExpression (SS [,] SS PropertyNameAndValueList)?
PropertyName 				<- Identifier
							/ StringLiteral
							/ NumericLiteral
MemberExpression 			<- (PrimaryExpression / FunctionExpression) (OPENSQUARE SS Expression SS CLOSESQUARE / DOT Identifier)*
							/ NEW SS MemberExpression SS Arguments
NewExpression 				<- MemberExpression
							/ NEW SS NewExpression
CallExpression 				<- MemberExpression SS Arguments (
								(SS Arguments
								/ OPENSQUARE SS Expression SS CLOSESQUARE
								/ DOT Identifier) )*
Arguments 					<- OPEN SS (ArgumentList SS)? CLOSE
ArgumentList 				<- AssignmentExpression (SS COMMA SS AssignmentExpression)*
LeftHandSideExpression 		<- CallExpression
							/ NewExpression
PostfixExpression 			<- LeftHandSideExpression (WSNT ("++" / "--"))?
UnaryExpression 			<- PostfixExpression
							/ ( DELETE / VOID / TYPEOF / "++" / "--" / PLUS / MINUS / TILDE / EXCLAMATION ) SS UnaryExpression
MultiplicativeExpression 		<- UnaryExpression (SS (ASTERISK / FORWARDSLASH / PERCENT) SS UnaryExpression)*
AdditiveExpression 			<- MultiplicativeExpression (SS (PLUS / MINUS) SS MultiplicativeExpression)*
ShiftExpression 				<- AdditiveExpression (SS ("<<" / ">>>" / ">>" ) SS AdditiveExpression)*
RelationalExpression 		<- ShiftExpression (SS ("<=" / ">=" / "<" / ">" / INSTANCEOF / IN) SS ShiftExpression)*
RelationalExpressionNoIn 	<- ShiftExpression (SS ("<=" / ">=" / "<" / ">" / INSTANCEOF ) SS ShiftExpression)*
EqualityExpression 			<- RelationalExpression (SS ("===" / "!!===" / "==" / "!!=" ) SS RelationalExpression)*
EqualityExpressionNoIn 		<- RelationalExpressionNoIn (SS ( "===" / "!!===" / "==" / "!!=" ) SS RelationalExpressionNoIn)*
BitwiseANDExpression 		<- EqualityExpression (SS AMP SS EqualityExpression)*
BitwiseANDExpressionNoIn 	<- EqualityExpressionNoIn (SS AMP SS EqualityExpressionNoIn)*
BitwiseXORExpression 		<- BitwiseANDExpression (SS "^" SS BitwiseANDExpression)*
BitwiseXORExpressionNoIn 	<- BitwiseANDExpressionNoIn (SS "^" SS BitwiseANDExpressionNoIn)*
BitwiseORExpression 		<- BitwiseXORExpression (SS VERTICALBAR SS BitwiseXORExpression)*
BitwiseORExpressionNoIn 	<- BitwiseXORExpressionNoIn (SS VERTICALBAR SS BitwiseXORExpressionNoIn)*
LogicalANDExpression 		<- BitwiseORExpression (SS "&&" SS BitwiseORExpression)*
LogicalANDExpressionNoIn 	<- BitwiseORExpressionNoIn (SS "&&" SS BitwiseORExpressionNoIn)*
LogicalORExpression 		<- LogicalANDExpression (SS "||" SS LogicalANDExpression)*
LogicalORExpressionNoIn 	<- LogicalANDExpressionNoIn (LogicalORExpressionNoIn SS "||" SS LogicalANDExpressionNoIn)*
ConditionalExpression 		<- LogicalORExpression (SS QUESTION SS AssignmentExpression SS COLON SS AssignmentExpression)?
ConditionalExpressionNoIn 	<- LogicalORExpressionNoIn (SS QUESTION SS AssignmentExpressionNoIn SS COLON SS AssignmentExpressionNoIn)?
AssignmentExpression 		<- LeftHandSideExpression SS AssignmentOperator SS AssignmentExpression
							/ ConditionalExpression
AssignmentExpressionNoIn 	<- LeftHandSideExpression SS AssignmentOperator SS AssignmentExpressionNoIn
							/ ConditionalExpressionNoIn
AssignmentOperator 			<- EQUAL / "*=" / "/=" / "%=" / "+=" / "-=" / "<<=" / ">>=" / ">>>=" / "&=" / "^=" / "|="
Expression 					<- AssignmentExpression (SS COMMA SS AssignmentExpression)*
ExpressionNoIn 				<- AssignmentExpressionNoIn (SS COMMA SS AssignmentExpressionNoIn)*

/* Statements: */
Statement 					<- SS !!(&CLOSECURLY) (Block
							/ VariableStatement
							/ EmptyStatement
							/ IfStatement
							/ IterationStatement
							/ ContinueStatement
							/ BreakStatement
							/ ReturnStatement
							/ WithStatement
							/ LabelledStatement
							/ SwitchStatement
							/ ThrowStatement
							/ ExpressionStatement
							/ TryStatement)
StatementOrError				<- Statement / NoStatementError
NoStatementError			<- .{EndOfSource / StartOfStatement}
Block 						<- OPENCURLY SS (StatementList SS)? CloseBlock
CloseBlock					<- CLOSECURLY / CloseBlockError
CloseBlockError				<- .{CLOSECURLY / EndOfSource}
StatementList 				<- Statement+
VariableStatement 			<- VAR SS VariableDeclarationList EndOfStatement
VariableDeclarationList 		<- VariableDeclaration (SS COMMA SS VariableDeclaration)*
VariableDeclarationListNoIn 	<- VariableDeclarationNoIn (SS COMMA SS VariableDeclarationNoIn)*
VariableDeclaration 			<- Identifier SS Initialiser?
VariableDeclarationNoIn 		<- Identifier SS InitialiserNoIn?
Initialiser 					<- EQUAL SS AssignmentExpression
InitialiserNoIn 				<- EQUAL SS AssignmentExpressionNoIn
EmptyStatement 				<- SEMICOLON SS
ExpressionStatement 			<- !!(&(OPENCURLY / FUNCTION)) Expression EndOfStatement
IfStatement 					<- IF SS OPEN SS Expression SS CLOSE SS Statement (SS ELSE SS Statement)?
IterationStatement 			<- DoStatement / WhileStatement / ForStatement
ContinueStatement 			<- CONTINUE WSNT Identifier?
BreakStatement 				<- BREAK WSNT Identifier?
ReturnStatement 				<- RETURN WSNT Expression?
WithStatement 				<- WITH SS OPEN SS Expression SS CLOSE Statement
SwitchStatement 				<- SWITCH SS OPEN SS Expression SS CLOSE CaseBlock
CaseBlock 					<- OPENCURLY SS (CaseClauses SS)? (DefaultClause SS (CaseClauses SS)?)? CLOSECURLY
CaseClauses 				<- CaseClause (SS CaseClause)*
CaseClause 					<- CASE SS Expression SS COLON SS StatementList?
DefaultClause 				<- DEFAULT SS COLON SS StatementList?
LabelledStatement 			<- Identifier SS COLON SS Statement
ThrowStatement 				<- THROW WSNT Expression EndOfStatement
TryStatement 				<- TRY SS Block SS (Catch SS Finally / Catch / Finally)
Catch 						<- CATCH SS OPEN SS Identifier SS CLOSE SS Block
Finally 						<- FINALLY SS Block

/* Iteration statements */
DoStatement					<- DO StatementOrError WhileClause EndOfStatement
WhileStatement				<- WhileClause StatementOrError
ForStatement				<- ForClause StatementOrError
WhileClause					<- SS WHILE SS RestOfWhileClause
RestOfWhileClause			<- OPEN SS Expression SS CLOSE / WhileClauseError
WhileClauseError			<- OPEN SS CLOSE / .{BRACKET / EndOfSource}
ForClause					<- FOR SS RestOfForClause
RestOfForClause				<- OPEN SS ForConditions SS CLOSE / ForClauseError
ForClauseError				<- OPEN SS CLOSE / .{SEMICOLON / BRACKET / EndOfSource}
ForConditions				<- ForConditionsVAR / ForConditionsLeft / ForConditionsNoIn
ForConditionsVAR			<- VAR SS (
								VariableDeclarationNoIn SS IN Expression
								/ VariableDeclarationListNoIn SS SEMICOLON SS Expression? SS SEMICOLON SS Expression?)
ForConditionsLeft			<- LeftHandSideExpression SS IN SS Expression
ForConditionsNoIn			<- ExpressionNoIn? SS SEMICOLON SS Expression? SS SEMICOLON SS Expression?
								

/* Functions and Programs */
FunctionDeclaration 			<- SS FUNCTION WhiteSpace+ Identifier SS FunctionDefinition
FunctionExpression 			<- SS FUNCTION (WhiteSpace+ Identifier)? SS FunctionDefinition
FunctionDefinition 			<- SS OpenList SS FormalParameterList? SS CloseList SS OpenFunction SS FunctionBody SS CloseFunction
OpenFunction 				<- OPENCURLY / OpenFunctionError
OpenFunctionError 			<- .{OPENCURLY / EndOfSource}
OpenList 					<- OPEN / OpenListError
OpenListError 				<- .{OPEN / EndOfSource}
CloseFunction				<- CLOSECURLY / CloseFunctionError
CloseFunctionError			<- .{CLOSECURLY / EndOfSource}
CloseList 					<- CLOSE / CloseListError
CloseListError 				<- .{CLOSE / EndOfSource}
FormalParameterList 			<- Identifier (SS COMMA SS Identifier)*
FunctionBody 				<- SourceElements?
Program 					<- SourceElements SS EndOfSource / ProgramError
ProgramError 				<- .{EndOfSource}
SourceElements 				<- SourceElement+
SourceElement 				<- FunctionDeclaration / Statement


/* Universal Resource Identifier Character Classes */
uri 							<- uriCharacters?
uriCharacters 				<- uriCharacter+
uriCharacter 					<- uriReserved
							/ uriUnescaped
							/ uriEscaped
uriReserved 					<- SEMICOLON / FORWARDSLASH / QUESTION / COLON / AT / AMP / EQUAL / PLUS / DOLLAR / COMMA
uriUnescaped 				<- uriAlpha
							/ DecimalDigit
							/ uriMark
uriEscaped 					<- PERCENT HexDigit HexDigit
uriAlpha 					<- [a-zA-Z]
uriMark 						<- MINUS / UNDERSCORE / DOT / EXCLAMATION / TILDE / ASTERISK / SINGLEQUOTE / OPEN / CLOSE

/* Regular Expressions: */
Pattern 						<- Disjunction
Disjunction 					<- Alternative (SS VERTICALBAR SS Alternative)*
Alternative 					<- (SS Term)*
Term 						<- Assertion / Atom Quantifier?
Assertion 					<- "^" / DOLLAR / BACKSLASH [bB]
Quantifier 					<- QuantifierPrefix QUESTION?
QuantifierPrefix 				<- ASTERISK
							/ PLUS
							/ QUESTION
							/ OPENCURLY SS DecimalDigits (SS COMMA (SS DecimalDigits)?)? SS CLOSECURLY
Atom 						<- PatternCharacter
							/ DOT
							/ BACKSLASH AtomEscape
							/ CharacterClass
							/ OPEN (QUESTION (COLON / EQUAL / EXCLAMATION))? Disjunction CLOSE
PatternCharacter 			<- !!(&[^$\\.*+?()\[\]{}|]) .
AtomEscape 				<- DecimalEscape
							/ CharacterEscape
							/ CharacterClassEscape
CharacterEscape 			<- ControlEscape
							/ "c" ControlLetter
							/ HexEscapeSequence
							/ UnicodeEscapeSequence
							/ IdentityEscape
ControlEscape 				<- [fnrtv]
ControlLetter 				<- [a-zA-Z]
IdentityEscape 				<- !!(&IdentifierPart) .
DecimalEscape 				<- DecimalIntegerLiteral !!(&DecimalDigit)
CharacterClassEscape 		<- [dDsSwW]
CharacterClass 				<- OPENSQUARE "^"? ClassRanges CLOSESQUARE
ClassRanges 				<- NonemptyClassRanges?
NonemptyClassRanges 		<- ClassAtom (NonemptyClassRangesNoDash / MINUS ClassAtom ClassRanges)
NonemptyClassRangesNoDash 	<- ClassAtom
							/ ClassAtomNoDash (NonemptyClassRangesNoDash / MINUS ClassAtom ClassRanges)
ClassAtom 					<- MINUS
							/ ClassAtomNoDash
ClassAtomNoDash 			<- !!(&(BACKSLASH / CLOSESQUARE / MINUS)) .
							/ BACKSLASH ClassEscape
ClassEscape 				<- DecimalEscape
							/ [b]
							/ CharacterEscape
							/ CharacterClassEscape

/* The following are not part of the ECMAScript grammar. They are added for clarity and simplicity of the above grammar rule definitions. */
SS 							<- ([\s\t\x00000A\x00000B\x00000C\x00000D] / Comment)*
WSNT 						<- (!!(&LineTerminator) (WhiteSpace / Comment))*
AMP 						<- "&" 
ASTERISK 					<- "*"
AT 							<- "@"
BACKSLASH 				<- "\\"
BREAK 						<- "break"
BRACKET					<- OPEN / OPENCURLY / OPENSQUARE / CLOSE / CLOSECURLY / CLOSESQUARE
CASE 						<- "case"
CATCH 						<- "catch"
CLOSE 						<- ")"
CLOSECURLY 				<- "}"
CLOSESQUARE 				<- "]"
COLON 						<- ":"
COMMA 					<- ","
CONTINUE 					<- "continue"
CR 							<- "\x00000D"
DEFAULT 					<- "default"
DELETE 					<- "delete"
DO 							<- "do"
DOLLAR 					<- "$"
DOT 						<- "."
DOUBLEQUOTE 				<- "\""
EndOfStatement 				<- SS (EndOfSource / !!(&CLOSECURLY) SEMICOLON / &CLOSECURLY SEMICOLON? )
StartOfStatement				<- OPENCURLY / VAR / FOR / DO / WITH / SWITCH / THROW / TRY / BRACKET / WHILE / IF / CONTINUE / BREAK / RETURN
EndOfSource 				<- !!.
ELSE 						<- "else"
EMPTY 						<- ""
EQUAL 						<- "="
EXCLAMATION 				<- "!!"
FF 							<- [\x00000C]
FINALLY 					<- "finally"
FOR 						<- "for"
FORWARDSLASH 			<- "/"
FUNCTION 					<- "function"
IF 							<- "if"
IN 							<- "in"
INFINITY 					<- "Infinity"
INSTANCEOF 				<- "instanceof"
LF 							<- "\x00000A"
MINUS 						<- "-"
NEW 						<- "new"
OPEN 						<- "("
OPENCURLY 				<- "{"
OPENSQUARE 				<- "["
PERCENT 					<- "%"
PLUS 						<- "+"
QUESTION 					<- "?"
RETURN 					<- "return"
SEMICOLON 				<- ";"
SINGLEQUOTE 				<- "''"
SPACE 						<- " "
SWITCH 					<- "switch" 
TAB 						<- [\t]
THROW 					<- "throw"
THIS 						<- "this"
TILDE 						<- "~"
TRY 						<- "try"
TYPEOF 					<- "typeof"
UNDERSCORE 				<- "_"
VAR 						<- "var"
VERTICALBAR 				<- "|"
VOID 						<- "void"
VT 							<- "\x00000B"
WHILE 						<- "while"
WITH 						<- "with"'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:35'!
grammarPEG
^'Grammar			<-	Definition+ !!.
Definition			<-	s Identifier s (ASSIGN / DefinitionError) s Expression s
DefinitionError		<-	(!!S .)*
Expression			<-	Sequence ((SLASH s Sequence) / (SequenceError s))*
Sequence			<-	Node+
SequenceError		<-	SLASH
Node				<-	Prefix? Primary Suffix? s
					/	!!SLASH !!(Identifier s ASSIGN) !!CLOSE_PAREN !!CLOSE_BRACE NodeError s
NodeError			<-	.
Primary				<-	Reference / Group / Literal / Range / DOT
Reference			<-	Identifier s !!ASSIGN
Group				<-	OPEN_PAREN s Expression s CLOSE_PAREN
Prefix				<-	AND / NOT
Suffix				<-	Cardinality / QUESTION / STAR / PLUS

Literal				<-	QUOTE LiteralEntity{QUOTE}
					/	DOUBLE_QUOTE LiteralEntity{DOUBLE_QUOTE}
LiteralEntity			<-	Escape / .

Range				<-	OPEN_BRACKET s "^"? RangeSet{1,CLOSE_BRACKET}
RangeSet			<-	s LiteralEntity DASH LiteralEntity s
					/	s LiteralEntity s
Cardinality			<-	OPEN_BRACE s (CardinalityRange / CardinalityLoopMin / CardinalityRangeMin / CardinalityLoop) s CLOSE_BRACE
CardinalityRangeMin	<-	NumLiteral
CardinalityRange	<-	NumLiteral s COMMA s NumLiteral
CardinalityLoopMin	<-	NumLiteral s COMMA s Expression
CardinalityLoop		<-	Expression

Identifier				<-	[a-zA-Z_] [a-zA-Z0-9_]*
NumLiteral			<-	"Infinity" / "0" / [1-9] [0-9]*
Escape				<-	BACKSLASH [x] [0-9A-F]{6}
					/	BACKSLASH [nrts\-\\\[\]\''\"]
					/	EscapeError
EscapeError			<-	BACKSLASH .

s					<-	S*
S					<-	whitespace+
					/	comment
comment			<-	OPEN_COMMENT comment_body{CLOSE_COMMENT}
comment_body		<-	comment
					/	.
whitespace			<-	[\s\t\n\r]

ASSIGN				<-	"<-"
SLASH				<-	"/"
BACKSLASH		<-	"\\"
AND				<-	"&"
NOT				<-	"!!"
COMMA				<-	","
QUESTION			<-	"?"
STAR				<-	"*"
PLUS				<-	"+"
DASH				<-	"-"
DOT				<-	"."
QUOTE				<-	"''"
DOUBLE_QUOTE	<-	''"''
OPEN_BRACKET	<-	"["
CLOSE_BRACKET	<-	"]"
OPEN_PAREN		<-	"("
CLOSE_PAREN		<-	")"
OPEN_BRACE		<-	"{"
CLOSE_BRACE		<-	"}"
OPEN_COMMENT	<-	"/*"
CLOSE_COMMENT	<-	"*/"
'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 23:10'!
grammarSmalltalk
^'/* Lexical Primitives */
Token 					<- Number / Keyword / BinarySelector / Identifier / BlockArgument / AssignmentOperator / CharacterConstant / String / SpecialCharacter
Digit					<- [0-9] 
Letter					<- [A-Za-z] 
BinaryCharacter			<-[+/\\*~<>=@%|&?!!,]
WhitespaceCharacter 	<- [\t\s\n\r]
EndOfMethod 			<- WhitespaceCharacter* !!.
BACKQUOTE 			<- "`"
CLOSE 					<- ")"
CLOSECURLY			<- "}"
CLOSEPRAGMA 		<- ">"
CLOSESQUARE			<- "]"
COLON					<- ":"
DASH 					<- "-"
DOUBLEQUOTE 			<- "\""
EQUALS 				<- "="
FALSELITERAL			<- "false"
HASH 					<- "#"
NILLITERAL				<- "nil"
OPEN 					<- "("
OPENCURLY			<- "{"
OPENPRAGMA 			<- "<"
OPENSQUARE			<- "["
PERIOD 				<- "."
RETURN 				<- "^"
SELF 					<- "self"
SEMICOLON 			<- ";"
SINGLEQUOTE 			<- "''"
SUPER 					<- "super"
THISCONTEXT			<- "thisContext"
TRUELITERAL 			<- "true"
UNDERSCORE 			<- "_"
VERTICALBAR 			<- "|"
NonQuoteCharacter		<- Digit / Letter / BinaryCharacter / WhitespaceCharacter / BACKQUOTE / UNDERSCORE / OPEN / CLOSE / OPENSQUARE / CLOSESQUARE / OPENCURLY / CLOSECURLY / RETURN / COLON / SEMICOLON / PERIOD / DASH / HASH
Digits 					<- Digit+
BigDigits 				<- (Digit / Letter)+
Number 					<- Digits ("r" DASH? BigDigits / OptionalFractionAndExponent)
NotANumber 			<- !!(&Number) Token
OptionalFractionAndExponent <- (PERIOD Digits)? ([eds] DASH? Digits)?
ExtendedLetter 			<- Letter / UNDERSCORE
Identifier 				<- ExtendedLetter (ExtendedLetter / Digit)*
BlockArgument 			<- Separator? COLON Separator? Identifier / BlockArgumentError
BlockArgumentError 		<- Separator? (COLON / Identifier) Separator? (COLON / &VERTICALBAR / &CLOSESQUARE / EndOfMethod / !!Identifier)
AssignmentOperator 		<- ":="
Keyword 				<- Identifier COLON
BinarySelector 			<- (DASH / BinaryCharacter) (DASH / BinaryCharacter)?
UnarySelector 			<- Identifier !!COLON
CharacterConstant 		<- "$" (NonQuoteCharacter / DOUBLEQUOTE / SINGLEQUOTE)
Symbol 					<- Identifier / BinarySelector / Keyword+
String 					<- SINGLEQUOTE ((NonQuoteCharacter / SINGLEQUOTE SINGLEQUOTE / DOUBLEQUOTE)* SINGLEQUOTE) / StringError
StringError 				<- SINGLEQUOTE (NonQuoteCharacter / SINGLEQUOTE SINGLEQUOTE / DOUBLEQUOTE)* !!SINGLEQUOTE
						/ SINGLEQUOTE NonQuoteCharacter+ SINGLEQUOTE !!(&Separator) NonQuoteCharacter+ SINGLEQUOTE
Comment 				<- DOUBLEQUOTE (NonQuoteCharacter / SINGLEQUOTE)* DOUBLEQUOTE / UnterminatedCommentError
UnterminatedCommentError 	<- DOUBLEQUOTE (NonQuoteCharacter / SINGLEQUOTE)* !!DOUBLEQUOTE
Separator 				<- (WhitespaceCharacter / Comment)+
SpecialCharacter 		<- [#$@\[\\\]{|}~] / [\x0000A1-\x0000A7\x0000A9-\x0000AE\x0000B0-\x0000B3\x0000B5-\x0000B7\x0000B9-\x0000BF]
						/ [\x0000C6\x0000D0\x0000D7\x0000D8\x0000DE\x0000DF\x0000E6\x0000F0\x0000F7\x0000F8\x0000FE]
						/ [\x000110\x000111\x000126\x000127\x000131-\x000133\x000138\x00013F\x000140-\x000142\x000149-\x00014B]
						/ [\x000152\x000153\x000166\x000167\x002018\x002019\x00201C\x00201D\x0020AC\x002122\x002126\x00215B]
						/ [\x00215B-\x00215E\x002190-\x002193\x00266A\x00FC10]
/* Atomic Terms */
Literal 					<- DASH? Number / NamedLiteral / SymbolLiteral / CharacterConstant / String / ArrayLiteral / ByteArrayLiteral / BindingLiteral
NamedLiteral 			<- NILLITERAL / TRUELITERAL / FALSELITERAL
SymbolLiteral 			<- HASH (Symbol / String) / SymbolError
SymbolError 				<- HASH !!(&(OPEN / OPENSQUARE)) !!(Symbol / String)
ArrayLiteral 				<- HASH ArrayLiteralBody
ArrayLiteralBody 			<- OPEN Separator? ArrayLiteralElement? (Separator ArrayLiteralElement)* Separator? CLOSE
ArrayLiteralElement		<- (Literal / Symbol / ArrayLiteralBody / ByteArrayLiteralBody)
ByteArrayLiteral 			<- HASH ByteArrayLiteralBody / ByteArrayError
ByteArrayLiteralBody 		<- OPENSQUARE ByteArrayNumbers CLOSESQUARE
ByteArrayNumbers 		<- Separator? Number? (Separator Number)* Separator?
ByteArrayError 			<- HASH OPENSQUARE (Separator? (Number Separator)* NotANumber (Separator Number)* Separator? CLOSESQUARE / ByteArrayNumbers !!CLOSESQUARE)
BindingLiteral 			<- ExtendedBindingName / BindingReference
BindingName 			<- BindingNameError / !!(NamedLiteral / PseudoVariableName / SUPER) Identifier
BindingNameError 		<- Identifier SINGLEQUOTE
ExtendedBindingName 	<- BindingName (PERIOD BindingName)* / ExtendedBindingError
ExtendedBindingError 	<- ((PERIOD BindingName)+ / (BindingName PERIOD)+ / PERIOD) (Separator / &CLOSECURLY)
BindingReference 		<- HASH OPENCURLY Separator? ExtendedBindingName Separator? CLOSECURLY
/* Expressions and Statements */
Primary 					<- ExtendedBindingName / BindingReference / PseudoVariableName / Literal / BlockConstructor / OPEN Expression CLOSE
PseudoVariableName 	<- SELF / THISCONTEXT
UnaryMessage 			<- Separator? UnarySelector
BinaryMessage 			<- Separator? BinarySelector Separator? BinaryMessageArgument
BinaryMessageArgument 	<- Primary (Separator UnaryMessage)*
KeywordMessage 		<- (Separator? Keyword Separator? KeywordMessageArgument / InvalidKeywordMessageError)+
KeywordMessageArgument 	<- Primary (Separator UnaryMessage)* Separator? BinaryMessage*
InvalidKeywordMessageError 	<- Keyword Separator? !!(&KeywordMessageArgument)
CascadedMessages 		<- (Separator? CascadedMessage)*
CascadedMessage 		<- CascadeError / SEMICOLON (KeywordMessage / BinaryMessage / UnaryMessage )
CascadeError 			<- SEMICOLON !!(&(KeywordMessage / BinaryMessage / UnaryMessage))
Messages 				<- Separator? (UnaryMessage+ BinaryMessage* KeywordMessage? / BinaryMessage+ KeywordMessage? / KeywordMessage)
RestOfExpression 		<- (Messages CascadedMessages)?
Expression 				<- (SUPER Messages CascadedMessages / SuperError)
						/ (ExtendedBindingName / BindingReference) Separator? (AssignmentOperator Separator? Expression / RestOfExpression)
 						/ Keyword EQUALS Expression
						/ Primary RestOfExpression
						/ ExpressionError
ExpressionError 			<- Separator? AssignmentOperator PERIOD?
SuperError 				<- SUPER Separator? !!Messages
ExpressionList 			<- Expression (PERIOD Expression)* PERIOD?
Temporaries 			<- Separator? (VERTICALBAR TemporaryList? VERTICALBAR / TemporariesError)
TemporariesError 		<- VERTICALBAR TemporaryList? !!VERTICALBAR
TemporaryList 			<-Separator? Identifier (Separator Identifier)* Separator?
DeclaredVariableName 	<- BindingName
Statements 				<- Separator? (ReturnStatement / Expression Separator? (PERIOD Statements)? )?
ReturnStatement 			<- RETURN Separator? Expression (PERIOD (Separator? StatementError)?)? / ReturnError
ReturnError 				<- RETURN Separator? (CLOSESQUARE / CLOSE / EndOfMethod)
StatementError 			<- (!!(&CLOSESQUARE) Token)+ CLOSESQUARE
						/ (!!(&CLOSE) Token)+ CLOSE
						/ Token+ EndOfMethod
BlockConstructor 		<- OPENSQUARE Separator? BlockDeclarations? Statements Separator? CLOSESQUARE / UnterminatedBlockError
UnterminatedBlockError 	<- OPENSQUARE Separator? BlockDeclarations? Separator? (&PERIOD / Statements) Separator? !!(&CLOSESQUARE)
BlockDeclarations 		<- Temporaries
 						/ BlockArgument+ Separator? VERTICALBAR Temporaries?
BlockDeclarationError 	<- (COLON Separator?)* BlockArgument? (COLON Separator?)* &VERTICALBAR?
/* Methods */
Method 					<- Separator? MessagePattern MethodBody Separator? (EndOfMethod / MethodError)
MethodBody				<- Pragmas? Temporaries? Statements?
						/ Temporaries? Pragmas? Statements?
MethodError 				<- .* !!.
MessagePattern 			<- KeywordPattern / BinaryPattern / UnarySelector
BinaryPattern 			<- BinarySelector Separator MessageArgument / BinaryPatternError
BinaryPatternError 		<- BinarySelector !!(Separator MessageArgument)
KeywordPattern 			<- KeywordWithArgument (Separator KeywordWithArgument)* / KeywordPatternError
KeywordWithArgument 	<- KeywordPatternError / Keyword Separator? MessageArgument
KeywordPatternError 		<- Keyword Separator? Keyword / Keyword !!(Separator? MessageArgument)
MessageArgument 		<- Identifier
Pragma 					<- OPENPRAGMA PragmaBody CLOSEPRAGMA / PragmaError
PragmaKeyword 			<- Keyword Separator? Literal
PragmaBody 			<- Separator? ((PragmaKeyword (Separator PragmaKeyword)*) / UnarySelector) Separator?
PragmaError 			<- OPENPRAGMA (
							EndOfMethod
							/ Separator? (PragmaKeyword Separator)* (Keyword Separator?)+ Separator? (PragmaKeyword Separator)* Separator? CLOSEPRAGMA?
							/ PragmaBody !!CLOSEPRAGMA
							/ Separator? Token (Separator? !!(&CLOSEPRAGMA) Token)* Separator? (CLOSEPRAGMA / EndOfMethod)
						)
Pragmas 				<- Separator? Pragma (Separator? Pragma)*'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:36'!
grammarWiki
	"This syntax is variation of google wiki syntax (http://code.google.com/p/support/wiki/WikiSyntax). It is used to mark up the package comments so that they can be turned into web pages. It is important that the mark-up isn't visually obtrusive so that the comments are still comfortably readable.
	The three major players in wiki syntax are:
		http://code.google.com/p/support/wiki/WikiSyntax
		http://en.wikipedia.org/wiki/Help:Wiki_markup
		http://c2.com/cgi/wiki?TextFormattingRules
	"
	^
'Page <- (Preformatted / Code / UnorderedList / OrderedList / Heading / Table / Paragraph / Empty)*

LineCharacter <- [^\n]
Flow <- Escape / Bold / Italic / LinkShort / LinkFull / LineCharacter
Escape <- "**" / "__" / "[["
Bold <- "*" Flow{"*"}
Italic <- "_" Flow{"_"}
LinkShort <- "[" .{&[>\]]} "]"
LinkFull <- "[" Flow{">"} .{"]"}

Line <- Flow{1,"\n"}
Paragraph <- Line
Empty <- "\n"
Preformatted <- "---\n" .{"---\n"} 
Code <- "{{{\n" .{"}}}\n"} 
Whitespace <- [\t\s]*
Heading		<-	Heading4 / Heading3 / Heading2 / Heading1
Heading1	<-	Whitespace "= " Flow{" =\n"}
Heading2	<-	Whitespace "== " Flow{" ==\n"}
Heading3	<-	Whitespace "=== " Flow{" ===\n"}
Heading4	<-	Whitespace "==== " Flow{" ====\n"}

Bullet1 <-	Whitespace "*" Line
Bullet2 <-	Whitespace "**" Line
Bullet3 <-	Whitespace "***" Line
UnorderedList <- (UnorderedList2 / Bullet1)+
UnorderedList2 <- (UnorderedList3 / Bullet2)+
UnorderedList3 <- Bullet3+

Hash1 <- Whitespace "#" Line
Hash2 <- Whitespace "##" Line
Hash3 <- Whitespace "###" Line
OrderedList <- (OrderedList2 / Hash1)+
OrderedList2 <- (OrderedList3 / Hash2)+
OrderedList3 <- Hash3+

Table <-	HeadingRow TableRow*
HeadingRow <-	Whitespace "||" HeadingCell{"\n"}
HeadingCell	<-	Flow{"||"}
TableRow <-	Whitespace "||" Cell{"\n"}
Cell	<-	Flow{"||"}
'! !

!PEGParser class methodsFor: 'grammars' stamp: 'nice 1/14/2011 22:36'!
grammarXML
^'/* Documents */
document			<-	prolog element Misc*

/* Characters */
Char				<-	[\x000001-\x00D7FF \x00E000-\x00FFFD \x010000-\x10FFFF]
RestrictedChar		<-	[\x000001-\x000008 \x00000B-\x00000C \x00000E-\x00001F \x00007F-\x000084 \x000086-\x00009F]

/* Common Syntactic Constructs */
S					<-	[\s\t\r\n]+
NameStartChar		<-	[: A-Z _ a-z \x0000C0-\x0000D6 \x0000D8-\x0000F6 \x0000F8-\x0002FF \x000370-\x00037D \x00037F-\x001FFF
						\x00200C-\x00200D \x002070-\x00218F \x002C00-\x002FEF \x003001-\x00D7FF \x00F900-\x00FDCF
						\x00FDF0-\x00FFFD /* The following range is beyond javascripts character set: \x010000-\x0EFFFF */]
NameChar			<-	NameStartChar / [\- . 0-9 \x0000B7 \x000300-\x00036F \x00203F-\x002040]
Name				<-	NameStartChar NameChar*
Names				<-	Name ("\s" Name)*
Nmtoken			<-	NameChar+
Nmtokens			<-	Nmtoken ("\s" Nmtoken)*
EntityValue			<-	["] ([^%&"] / PEReference / Reference)* ["]
					/	[''] ([^%&''] / PEReference / Reference)* ['']
AttValue				<-	["] ([^<&"] / Reference)* ["]
					/	[''] ([^<&''] / Reference)* ['']
SystemLiteral		<-	(["] [^"]* ["]) / ([''] [^'']* [''])
PubidLiteral			<-	["] PubidChar{["]} / [''] PubidChar{['']} ['']
PubidChar			<-	[\s \n \r a-zA-Z0-9 \-''()+,./:=?;!!*#@$_%]

/* Character Data and Markup */
CharData			<-	[^<&]{"]]>"}

/* Comments */
Comment			<-	"<!!--" Char{"-->"} "-->"

/* Processing Instructions */
PI					<-	"<?" PITarget (S Char{"?>"})? "?>"
PITarget				<-	!!([Xx] [Mm] [Ll]) Name

/* CData Sections */
CDSect				<-	CDStart CData CDEnd
CDStart				<-	"<!![CDATA["
CData				<-	Char{CDEnd}
CDEnd				<-	"]]>"

/* Prolog and Document Type Declaration */
prolog				<-	XMLDecl Misc* (doctypedecl Misc*)?
XMLDecl			<-	"<?xml" VersionInfo EncodingDecl? SDDecl? S? "?>"
VersionInfo			<-	S "version" Eq ([''] VersionNum [''] / ["] VersionNum ["])
Eq					<-	S? "=" S?
VersionNum			<-	"1.0" / "1.1"
Misc				<-	Comment / PI / S
doctypedecl			<-	"<!!DOCTYPE" S Name (S ExternalID)? S? ("[" intSubset "]" S?)? ">"
DeclSep				<-	PEReference / S
intSubset			<-	(markupdecl / DeclSep)*
markupdecl			<-	elementdecl / AttlistDecl / EntityDecl / NotationDecl / PI / Comment
extSubset			<-	TextDecl? extSubsetDecl
extSubsetDecl		<-	(markupdecl / conditionalSect / DeclSep)*

/* Standard Document Declaration */
SDDecl				<-	S "standalone" Eq (([''] ("yes" / "no") ['']) / (["] ("yes" / "no") ["]))

/* Logical Structures */
element				<-	EmptyElemTag
					/	STag content ETag

/* Start-Tags, End-Tags, Empty-Element Tags */
STag				<-	"<" Name (S Attribute)* S? ">"
Attribute				<-	Name Eq AttValue
ETag				<-	"</" Name S? ">"
content				<-	CharData? ((element / Reference / CDSect / PI / Comment / ElementError) CharData?)*
EmptyElemTag		<-	"<" Name (S Attribute)* S? "/>"
ElementError		<-	!!"</" "<"

/* Element Type Declaration */
elementdecl			<-	"<!!ELEMENT" S Name contentspec S? ">"
contentspec			<-	"EMPTY" / "ANY" / Mixed / children

/* Element Content */
children				<-	(choice / seq) [?*+]?
cp					<-	(Name / choice / seq) [?*+]?
choice				<-	"(" S? cp (S? "|" S? cp)+ S? ")"
seq					<-	"(" S? cp (S? "," S? cp)* S? ")"
Mixed				<-	"(" S? "#PCDATA" (S? "|" S? Name)* S? ")*"
					/	"(" S? "#PCDATA" S? ")"

/* Attribute-List Declaration */
AttlistDecl			<-	"<!!ATTLIST" S Name AttDef* S? ">"
AttDef				<-	S Name AttType S DefaultDecl
AttType				<-	StringType / TokenizedType / EnumeratedType
StringType			<-	"CDATA"
TokenizedType		<-	"IDREFS" / "IDREF" / "ID" / "ENTITY" / "ENTITIES" / "NMTOKENS" / "NMTOKEN"
EnumeratedType		<-	NotationType / Enumeration
NotationType		<-	"NOTATION" S "(" S? Name (S? "|" Name)* S? ")"
Enumeration			<-	"(" S? Nmtoken (S? "|" S? Nmtoken)* S? ")"
DefaultDecl			<-	"#REQUIRED" / "#IMPLIED" / ("#FIXED" S)? AttValue

/* Conditional Sections */
conditionalSect		<-	includeSect / ignoreSect
includeSect			<-	"<!![" S? "INCLUDE" S? "[" extSubsetDecl "]]>"
ignoreSect			<-	"<!![" S? "IGNORE" S? "[" ignoreSectContents* "]]>"
ignoreSectContents	<-	Ignore ("<!![" ignoreSectContents "]]>" Ignore)*
Ignore				<-	Char{"<!![" / "]]>"}

/* Character and Entity References */
CharRef				<-	"&#" [0-9]+ ";"
					/	"&#x" [0-9 a-f A-F]+ ";"
Reference			<-	EntityRef / CharRef / ReferenceError
EntityRef			<-	"&" Name ";"
PEReference		<-	"%" Name ";"
ReferenceError		<-	"&"

/* Entity Declarations */
EntityDecl			<-	GEDecl / PEDecl
GEDecl				<-	"<!!ENTITY" S Name S EntityDef S? ">"
PEDecl				<-	"<!!ENTITY" S "%" S Name S PEDef S? ">"
EntityDef			<-	EntityValue / (ExternalID NDataDecl?)
PEDef				<-	EntityValue / ExternalID
ExternalID			<-	"SYSTEM" S SystemLiteral
					/	"PUBLIC" S PubidLiteral S SystemLiteral
NDataDecl			<-	S "NDATA" S Name

/* Parsed Entities */
TextDecl			<-	"<?xml" VersionInfo? EncodingDecl S? "?>"
extParsedEnt		<-	(TextDecl? content)
EncodingDecl		<-	S "encoding" Eq (["] EncName ["] / [''] EncName [''])
EncName			<-	[A-Z a-z] [A-Z a-z 0-9 . _ \-]*

/* Notation Declarations */
NotationDecl			<-	"<!!NOTATION" S Name S (ExternalID / PublicID) S? ">"
PublicID				<-	"PUBLIC" S PubidLiteral
'! !

!PEGParser class methodsFor: 'class initialization' stamp: 'nice 1/14/2011 22:34'!
initialize
	Failure := Object new! !

!PEGParser class methodsFor: 'parsers' stamp: 'nice 1/14/2011 22:38'!
parserBootstrap
	"WARNING: This method was generated with the following code:
		PEGParser parserPEG parse: 'Grammar' stream: PEGParser grammarPEG actor: PEGParserGenerator new

	 *** This is circular. You need a working bootstrap to get a PEG parser to then generate source code to generate a PEG parser.
	 *** Do not replace this method unless you are 100% sure your new parser code is correct"

	| generator definitions |
	definitions := OrderedCollection new.
	generator := PEGParserParser new.
	definitions add: (generator Definition: 'Grammar' expression: (generator Sequence: (OrderedCollection new add: (generator Node: (generator Reference: 'Definition') modifier: nil cardinality: generator PLUS); add: (generator Node: generator DOT modifier: generator NOT cardinality: nil); yourself))).
	definitions add: (generator Definition: 'Definition' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 's'); add: (generator Reference: 'Identifier'); add: (generator Reference: 's'); add: (generator Expression: (generator Reference: 'ASSIGN') rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Reference: 'DefinitionError')); yourself)); add: (generator Reference: 's'); add: (generator Reference: 'Expression'); add: (generator Reference: 's'); yourself))).
	definitions add: (generator Definition: 'DefinitionError' expression: (generator Node: (generator Sequence: (OrderedCollection new add: (generator Node: (generator Reference: 'S') modifier: generator NOT cardinality: nil); add: generator DOT; yourself)) modifier: nil cardinality: generator STAR)).
	definitions add: (generator Definition: 'Expression' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'Sequence'); add: (generator Node: (generator Expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'SLASH'); add: (generator Reference: 's'); add: (generator Reference: 'Sequence'); yourself)) rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Sequence: (OrderedCollection new add: (generator Reference: 'SequenceError'); add: (generator Reference: 's'); yourself))); yourself)) modifier: nil cardinality: generator STAR); yourself))).
	definitions add: (generator Definition: 'Sequence' expression: (generator Node: (generator Reference: 'Node') modifier: nil cardinality: generator PLUS)).
	definitions add: (generator Definition: 'SequenceError' expression: (generator Reference: 'SLASH')).
	definitions add: (generator Definition: 'Node' expression: (generator Expression: (generator Sequence: (OrderedCollection new add: (generator Node: (generator Reference: 'Prefix') modifier: nil cardinality: generator QUESTION); add: (generator Reference: 'Primary'); add: (generator Node: (generator Reference: 'Suffix') modifier: nil cardinality: generator QUESTION); add: (generator Reference: 's'); yourself)) rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Sequence: (OrderedCollection new add: (generator Node: (generator Reference: 'SLASH') modifier: generator NOT cardinality: nil); add: (generator Node: (generator Sequence: (OrderedCollection new add: (generator Reference: 'Identifier'); add: (generator Reference: 's'); add: (generator Reference: 'ASSIGN'); yourself)) modifier: generator NOT cardinality: nil); add: (generator Node: (generator Reference: 'CLOSE_PAREN') modifier: generator NOT cardinality: nil); add: (generator Node: (generator Reference: 'CLOSE_BRACE') modifier: generator NOT cardinality: nil); add: (generator Reference: 'NodeError'); add: (generator Reference: 's'); yourself))); yourself))).
	definitions add: (generator Definition: 'NodeError' expression: generator DOT).
	definitions add: (generator Definition: 'Primary' expression: (generator Expression: (generator Reference: 'Reference') rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Reference: 'Group')); add: (Array with: '/' with: #() with: (generator Reference: 'Literal')); add: (Array with: '/' with: #() with: (generator Reference: 'Range')); add: (Array with: '/' with: #() with: (generator Reference: 'DOT')); yourself))).
	definitions add: (generator Definition: 'Reference' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'Identifier'); add: (generator Reference: 's'); add: (generator Node: (generator Reference: 'ASSIGN') modifier: generator NOT cardinality: nil); yourself))).
	definitions add: (generator Definition: 'Group' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'OPEN_PAREN'); add: (generator Reference: 's'); add: (generator Reference: 'Expression'); add: (generator Reference: 's'); add: (generator Reference: 'CLOSE_PAREN'); yourself))).
	definitions add: (generator Definition: 'Prefix' expression: (generator Expression: (generator Reference: 'AND') rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Reference: 'NOT')); yourself))).
	definitions add: (generator Definition: 'Suffix' expression: (generator Expression: (generator Reference: 'Cardinality') rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Reference: 'QUESTION')); add: (Array with: '/' with: #() with: (generator Reference: 'STAR')); add: (Array with: '/' with: #() with: (generator Reference: 'PLUS')); yourself))).
	definitions add: (generator Definition: 'Literal' expression: (generator Expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'QUOTE'); add: (generator Node: (generator Reference: 'LiteralEntity') modifier: nil cardinality: (generator CardinalityLoop: (generator Reference: 'QUOTE'))); yourself)) rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Sequence: (OrderedCollection new add: (generator Reference: 'DOUBLE_QUOTE'); add: (generator Node: (generator Reference: 'LiteralEntity') modifier: nil cardinality: (generator CardinalityLoop: (generator Reference: 'DOUBLE_QUOTE'))); yourself))); yourself))).
	definitions add: (generator Definition: 'LiteralEntity' expression: (generator Expression: (generator Reference: 'Escape') rest: (OrderedCollection new add: (Array with: '/' with: #() with: generator DOT); yourself))).
	definitions add: (generator Definition: 'Range' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'OPEN_BRACKET'); add: (generator Reference: 's'); add: (generator Node: (generator Literal: '^') modifier: nil cardinality: generator QUESTION); add: (generator Node: (generator Reference: 'RangeSet') modifier: nil cardinality: (generator CardinalityLoopMin: 1 test: (generator Reference: 'CLOSE_BRACKET'))); yourself))).
	definitions add: (generator Definition: 'RangeSet' expression: (generator Expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 's'); add: (generator Reference: 'LiteralEntity'); add: (generator Reference: 'DASH'); add: (generator Reference: 'LiteralEntity'); add: (generator Reference: 's'); yourself)) rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Sequence: (OrderedCollection new add: (generator Reference: 's'); add: (generator Reference: 'LiteralEntity'); add: (generator Reference: 's'); yourself))); yourself))).
	definitions add: (generator Definition: 'Cardinality' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'OPEN_BRACE'); add: (generator Reference: 's'); add: (generator Expression: (generator Reference: 'CardinalityRange') rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Reference: 'CardinalityLoopMin')); add: (Array with: '/' with: #() with: (generator Reference: 'CardinalityRangeMin')); add: (Array with: '/' with: #() with: (generator Reference: 'CardinalityLoop')); yourself)); add: (generator Reference: 's'); add: (generator Reference: 'CLOSE_BRACE'); yourself))).
	definitions add: (generator Definition: 'CardinalityRangeMin' expression: (generator Reference: 'NumLiteral')).
	definitions add: (generator Definition: 'CardinalityRange' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'NumLiteral'); add: (generator Reference: 's'); add: (generator Reference: 'COMMA'); add: (generator Reference: 's'); add: (generator Reference: 'NumLiteral'); yourself))).
	definitions add: (generator Definition: 'CardinalityLoopMin' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'NumLiteral'); add: (generator Reference: 's'); add: (generator Reference: 'COMMA'); add: (generator Reference: 's'); add: (generator Reference: 'Expression'); yourself))).
	definitions add: (generator Definition: 'CardinalityLoop' expression: (generator Reference: 'Expression')).
	definitions add: (generator Definition: 'Identifier' expression: (generator Sequence: (OrderedCollection new add: (generator Range: nil sets: (OrderedCollection new add: (97 to: 122); add: (65 to: 90); add: (95 to: 95); yourself)); add: (generator Node: (generator Range: nil sets: (OrderedCollection new add: (97 to: 122); add: (65 to: 90); add: (48 to: 57); add: (95 to: 95); yourself)) modifier: nil cardinality: generator STAR); yourself))).
	definitions add: (generator Definition: 'NumLiteral' expression: (generator Expression: (generator Literal: 'Infinity') rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Literal: '0')); add: (Array with: '/' with: #() with: (generator Sequence: (OrderedCollection new add: (generator Range: nil sets: (OrderedCollection new add: (49 to: 57); yourself)); add: (generator Node: (generator Range: nil sets: (OrderedCollection new add: (48 to: 57); yourself)) modifier: nil cardinality: generator STAR); yourself))); yourself))).
	definitions add: (generator Definition: 'Escape' expression: (generator Expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'BACKSLASH'); add: (generator Range: nil sets: (OrderedCollection new add: (120 to: 120); yourself)); add: (generator Node: (generator Range: nil sets: (OrderedCollection new add: (48 to: 57); add: (65 to: 70); yourself)) modifier: nil cardinality: (generator CardinalityRangeMin: 6)); yourself)) rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Sequence: (OrderedCollection new add: (generator Reference: 'BACKSLASH'); add: (generator Range: nil sets: (OrderedCollection new add: (110 to: 110); add: (114 to: 114); add: (116 to: 116); add: (115 to: 115); add: (45 to: 45); add: (92 to: 92); add: (91 to: 91); add: (93 to: 93); add: (39 to: 39); add: (34 to: 34); yourself)); yourself))); add: (Array with: '/' with: #() with: (generator Reference: 'EscapeError')); yourself))).
	definitions add: (generator Definition: 'EscapeError' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'BACKSLASH'); add: generator DOT; yourself))).
	definitions add: (generator Definition: 's' expression: (generator Node: (generator Reference: 'S') modifier: nil cardinality: generator STAR)).
	definitions add: (generator Definition: 'S' expression: (generator Expression: (generator Node: (generator Reference: 'whitespace') modifier: nil cardinality: generator PLUS) rest: (OrderedCollection new add: (Array with: '/' with: #() with: (generator Reference: 'comment')); yourself))).
	definitions add: (generator Definition: 'comment' expression: (generator Sequence: (OrderedCollection new add: (generator Reference: 'OPEN_COMMENT'); add: (generator Node: (generator Reference: 'comment_body') modifier: nil cardinality: (generator CardinalityLoop: (generator Reference: 'CLOSE_COMMENT'))); yourself))).
	definitions add: (generator Definition: 'comment_body' expression: (generator Expression: (generator Reference: 'comment') rest: (OrderedCollection new add: (Array with: '/' with: #() with: generator DOT); yourself))).
	definitions add: (generator Definition: 'whitespace' expression: (generator Range: nil sets: (OrderedCollection new add: (32 to: 32); add: (9 to: 9); add: (13 to: 13); add: (10 to: 10); yourself))).
	definitions add: (generator Definition: 'ASSIGN' expression: (generator Literal: '<-')).
	definitions add: (generator Definition: 'SLASH' expression: (generator Literal: '/')).
	definitions add: (generator Definition: 'BACKSLASH' expression: (generator Literal: '\')).
	definitions add: (generator Definition: 'AND' expression: (generator Literal: '&')).
	definitions add: (generator Definition: 'NOT' expression: (generator Literal: '!!')).
	definitions add: (generator Definition: 'COMMA' expression: (generator Literal: ',')).
	definitions add: (generator Definition: 'QUESTION' expression: (generator Literal: '?')).
	definitions add: (generator Definition: 'STAR' expression: (generator Literal: '*')).
	definitions add: (generator Definition: 'PLUS' expression: (generator Literal: '+')).
	definitions add: (generator Definition: 'DASH' expression: (generator Literal: '-')).
	definitions add: (generator Definition: 'DOT' expression: (generator Literal: '.')).
	definitions add: (generator Definition: 'QUOTE' expression: (generator Literal: '''')).
	definitions add: (generator Definition: 'DOUBLE_QUOTE' expression: (generator Literal: '"')).
	definitions add: (generator Definition: 'OPEN_BRACKET' expression: (generator Literal: '[')).
	definitions add: (generator Definition: 'CLOSE_BRACKET' expression: (generator Literal: ']')).
	definitions add: (generator Definition: 'OPEN_PAREN' expression: (generator Literal: '(')).
	definitions add: (generator Definition: 'CLOSE_PAREN' expression: (generator Literal: ')')).
	definitions add: (generator Definition: 'OPEN_BRACE' expression: (generator Literal: '{')).
	definitions add: (generator Definition: 'CLOSE_BRACE' expression: (generator Literal: '}')).
	definitions add: (generator Definition: 'OPEN_COMMENT' expression: (generator Literal: '/*')).
	definitions add: (generator Definition: 'CLOSE_COMMENT' expression: (generator Literal: '*/')).
	^generator Grammar: definitions! !

!PEGParser class methodsFor: 'parsers' stamp: 'nice 1/14/2011 22:37'!
parserPEG
	^self parserBootstrap parse: 'Grammar' stream: self grammarPEG reading positioning actor: PEGParserParser new! !

!PEGParser class methodsFor: 'parsers' stamp: 'nice 1/14/2011 22:37'!
parserWiki
	^self parserPEG parse: 'Grammar' stream: self grammarWiki reading positioning actor: PEGParserParser new! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:32'!
all: expressions
	| result object position |
	position := stream position.
	result := Array new: expressions size.
	expressions keysAndValuesDo: [:index :expression |
		(object := expression value) == Failure
			ifTrue: [stream position: position. ^Failure].
		result at: index put: object].
	^result! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:32'!
any: expressions
	| position object |
	position := stream position.
	expressions do: [:expression |
		(object := expression value) == Failure
			ifTrue:	[stream position: position]
			ifFalse:	[^object]].
	stream position: position.
	^Failure! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:32'!
anything
	| position |
	position := stream position.
	[stream read: 1 into: cache at: 1] on: Incomplete do: [stream position: position. ^Failure].
	^cache at: 1! !

!PEGParser methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:32'!
bufferSize: aBufferSize
	cache size < aBufferSize ifTrue: [cache := String new: aBufferSize]! !

!PEGParser methodsFor: 'accessing' stamp: 'nice 1/14/2011 22:31'!
caches
	^caches! !

!PEGParser methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:31'!
clear
	caches do: [:each | each become: Dictionary new]! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:32'!
definition: expression name: name
	| object position |
	position := stream position.
	object := expression value.
	object == Failure ifTrue: [^Failure].
	actor ifNil: [^object].
	^actor process: name object: object start: position stop: stream position! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:32'!
definition: expression name: name cache: expressionCache
	| object position entry |
	position := stream position.
	entry := expressionCache at: position ifAbsentPut:
		[object := expression value.
		(object ~~ Failure and: [actor notNil]) ifTrue:
			[object := actor process: name object: object start: position stop: stream position].
		stream position -> object].
	stream position: entry key.
	^entry value! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:32'!
excluding: intervals
	| position integer |
	position := stream position.
	[stream read: 1 into: cache at: 1] on: Incomplete do: [stream position: position. ^Failure].
	integer := (cache at: 1) asInteger.
	intervals do: [:interval | (interval includes: integer) ifTrue: [stream position: position. ^Failure]].
	^cache at: 1! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
explore: expression
	| object position |
	position := stream position.
	object := expression value.
	stream position: position.
	^object! !

!PEGParser methodsFor: 'accessing' stamp: 'nice 1/14/2011 22:31'!
grammar
	^grammar! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
including: intervals
	| position integer |
	position := stream position.
	[stream read: 1 into: cache at: 1] on: Incomplete do: [stream position: position. ^Failure].
	integer := (cache at: 1) asInteger.
	intervals do: [:interval | (interval includes: integer) ifTrue: [^cache at: 1]].
	stream position: position.
	^Failure! !

!PEGParser methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 22:31'!
initialize
	grammar := Dictionary new.
	cache := String new: 1.
	caches := OrderedCollection new! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
literal: literal
	| position |
	position := stream position.
	[stream read: literal size into: cache at: 1] on: Incomplete do: [stream position: position. ^Failure].
	1 to: literal size do: [:i | (cache at: i) == (literal at: i) ifFalse: [stream position: position. ^Failure]].
	^literal! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
not: expression
	| position object |
	position := stream position.
	object := expression value.
	stream position: position.
	^object == Failure
		ifTrue:	[nil]
		ifFalse:	[Failure]! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
optional: expression
	| object |
	^(object := expression value) == Failure
		ifTrue:	[nil]
		ifFalse:	[object]! !

!PEGParser methodsFor: 'parsing' stamp: 'nice 1/14/2011 22:33'!
parse: definition stream: aStream actor: anActor
	"Parse @definition from aStream using @anActor to act on the matching rules.
	""	definition	<String>			identifies the rule of the grammar to apply to the input
		aStream		<ReadStream>	the input to parse
		anActor		<Actor>			receives callbacks from the parser for the successfully rules with the matching the input
		^			<Object>		result of the actor action for the @definition
	"
	| object |
	actor := anActor.
	stream := aStream reading.
	self clear.
	object := (grammar at: definition) value.
	^object == Failure
		ifTrue:	[nil]
		ifFalse:	[object]! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
repeat: expression min: min optional: optional
	| result object position |
	position := stream position.
	result := OrderedCollection new: min.
	min timesRepeat:
		[(object := expression value) == Failure
			ifTrue: [stream position: position. ^Failure].
		result add: object].
	optional timesRepeat:
		[position := stream position.
		(object := expression value) == Failure
			ifTrue: [stream position: position. ^result].
		result add: object].
	^result! !

!PEGParser methodsFor: 'operations' stamp: 'nice 1/14/2011 22:33'!
repeat: expression min: min test: test
	| result object position |
	position := stream position.
	result := OrderedCollection new: min.
	min timesRepeat:
		[object := test value.
		stream position: position.
		object == Failure ifFalse: [^Failure].
		(object := expression value) == Failure
			ifTrue: [stream position: position. ^Failure].
		result add: object].
	[position := stream position.
	test value == Failure] whileTrue:
		[stream position: position.
		(object := expression value) == Failure
			ifTrue: [stream position: position. ^result].
		result add: object].
	^result! !

!PEGParser methodsFor: 'parsing' stamp: 'nice 1/14/2011 22:34'!
validate: definition stream: aStream
	actor := nil.
	stream := aStream reading.
	self clear.
	^(grammar at: definition) value ~~ Failure! !

Object subclass: #XTNumberParser
	instanceVariableNames: 'in ch base sign absolute failBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!XTNumberParser class methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2011 22:48'!
on: aReadStream
	^ self basicNew
		initializeWithStream: aReadStream! !

!XTNumberParser class methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:48'!
parse: aReadable
	^ self parse: aReadable base: 10! !

!XTNumberParser class methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:48'!
parse: aReadable base: anInteger
	^ self parse: aReadable base: anInteger ifFail: [nil]! !

!XTNumberParser class methodsFor: 'as yet unclassified' stamp: 'cwp 9/14/2011 15:49'!
parse: aReadable base: anInteger ifFail: aBlock
	^ self new parse: aReadable base: anInteger ifFail: aBlock ! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 16:39'!
digitValue
	^ ch digitValue! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 16:35'!
fail
	failBlock value! !

!XTNumberParser methodsFor: 'error handling' stamp: 'cwp 9/14/2011 16:27'!
handleIncomplete: anIncomplete 
	^ absolute * sign! !

!XTNumberParser methodsFor: 'error handling' stamp: 'cwp 9/14/2011 16:26'!
handleParseError: aXTParseError 
	^ failBlock value! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 16:33'!
initialize
	base := 10.
	! !

!XTNumberParser methodsFor: 'as yet unclassified' stamp: 'cwp 9/13/2011 23:41'!
initializeWithStream: aReadStream
	self initialize.
	in := aReadStream.
	base := 10.! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 16:42'!
isDigit: anInteger
	^ anInteger > -1 and: [anInteger < base]! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 16:45'!
parse
	
	absolute := 0.
	[self parseSign.
	self parseDigits.
	self parseFraction]
		on: Incomplete
		do: [:nothing].
	^ absolute * sign! !

!XTNumberParser methodsFor: 'public' stamp: 'cwp 9/14/2011 16:32'!
parse: aReadable
	^ self parse: aReadable base: 10! !

!XTNumberParser methodsFor: 'public' stamp: 'cwp 9/14/2011 16:32'!
parse: aReadable base: anInteger
	^ self parse: aReadable base: anInteger ifFail: [nil]! !

!XTNumberParser methodsFor: 'public' stamp: 'cwp 9/14/2011 16:30'!
parse: aReadable base: anInteger ifFail: aBlock
	in := aReadable reading.
	base := anInteger.
	failBlock := [^ aBlock value].
	^ self parse! !

!XTNumberParser methodsFor: 'public' stamp: 'cwp 9/14/2011 16:43'!
parse: aReadable ifFail: aBlock
	^ self parse: aReadable base: 10 ifFail: aBlock! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 16:49'!
parseDigits
	self parseDigits: [:value | absolute * base + value]! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 17:06'!
parseDigits: aBlock
	| value |
	value := self digitValue.
	(self isDigit: value) ifFalse: [self fail].
	[absolute := aBlock value: value.
	ch := in get.
	value := self digitValue.
	self isDigit: value]
		whileTrue! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 17:10'!
parseFraction
	| scale |
	
	ch = $. ifTrue:
		[ch := in get.
		scale := 1.
		self parseDigits: 
			[:value | 
			scale := scale / base.
			value * scale + absolute]]! !

!XTNumberParser methodsFor: 'private' stamp: 'cwp 9/14/2011 00:12'!
parseSign
	ch := in get.
	ch = $-
		ifFalse: [sign := 1]
		ifTrue:
			[sign := -1.
			ch := in get]
		! !

Object subclass: #XTNumberPrinter
	instanceVariableNames: 'out number base'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Parsing'!

!XTNumberPrinter methodsFor: 'private' stamp: 'cwp 9/14/2011 22:21'!
print
	| digits n tmp |
	self printSign.
	tmp := ByteArray new writing.
	n := number.
	[n > 0] whileTrue:  
		[tmp put: (n rem: base).
		n := n quo: base].
	digits := tmp conclusion.
	digits size to: 1 by: -1 do: [:i | self put: (digits at: i)]! !

!XTNumberPrinter methodsFor: 'public' stamp: 'cwp 9/14/2011 22:18'!
print: aNumber on: aWriteable
	self print: aNumber on: aWriteable base: 10! !

!XTNumberPrinter methodsFor: 'public' stamp: 'cwp 9/14/2011 22:17'!
print: aNumber on: aWriteable base: anInteger
	out := aWriteable writing.
	number := aNumber.
	base := anInteger.
	self print.! !

!XTNumberPrinter methodsFor: 'private' stamp: 'cwp 9/14/2011 22:13'!
printSign
	number negative ifTrue:
		[out put: $-.
		number := number negated]! !

!XTNumberPrinter methodsFor: 'private' stamp: 'cwp 9/14/2011 22:21'!
put: value
	^ out put: (Character digitValue: value) asLowercase! !
PEGParser initialize!
